#!/usr/bin/env node

/*
    Get all matching files in the cwd ".vow.js"

    Compiling Files:
        Found 15 files
        Found 98 guarantees

    [95/98 Completed]

    Failures:
    [❌ ] Bread is gluten free

    ////////////////////////////////////////////////

    Sections:
        Header

        Test Case Details
*/

const extension = ".vow.js";
const cwd = process.cwd();


const keeper = require('./keeper')({
    base: process.cwd()
});

global.connect = require('./plugins/venatici/require')({
    folders: ["plugins"],
    extensions: [".js"],
    mainFiles: ["index"]
});
global.prynt = connect("venatici/prynt");


const presets = {
    // wait the specified number of milliseconds after receiving a yes,
    // before ending the process
    wait_before_close: 2000
}

const launch = function(macros) {
    const {
        string: __str,
        cwd = null
    } = macros;

    const config = {
        script: require('path').resolve(__dirname, "eval.js")
    };

    if (cwd !== null) {
        config.cwd = cwd;
    }

    const proc = connect('venatici/fork')(config);

    proc.send(__str);

    return proc;
}

global.guarantee = function(vows) {
    const { wait_before_close } = presets;
    const caller_file = require('venatici/trace')()[1].getFileName();

    require('auriga/object/read')({
        object: vows,
        each: function(key, value, next) {
            const vow = vows[key];



            let evaluated = "var fn = ";
            evaluated += vow.toString();



            // const fn = eval(fn_string);
            //
            // fn({
            //     yes: () => {
            //         process.send("yes");
            //     },
            //     no: () => {
            //         process.send("no");
            //     }
            // })
            //


            evaluated += `;fn({
                yes: () => {
                    process.send('yess');
                    setTimeout(() => {
                        process.exit(0);
                    }, ${ wait_before_close })
                },
                no: () => {
                    process.send('noo');
                    process.exit(1);
                }
            })`;

            const proc = launch({
                string: evaluated,
                cwd
            });
            proc.on('message', (message) => {
                prynt(message);
            });

            return;

            // connect('venatici/exec')(evaluated, {
            //     cwd,
            //     stdout: function() {
            //         console.log("ok?")
            //     }
            // });

            //
            // /*
            //
            //
            //
            // */


            // const id = keeper.add({
            //     key,
            //     caller_file,
            //     evaluated
            // });

            next();
        },
        done: function() {
            prynt('done');
        }
    });
}

const vows = [];

require('auriga/circuit')()
.task({
    id: 1,
    fn: function(task) {
        require('venatici/dir/get-all-entities')({
            dp: process.cwd(),
            outputKind: "files array",
            success: (results) => {
                // keeper.addFiles({
                //     files: results
                // });


                for (let i=0; i <= results.length - 1; i++) {
                    const result = results[i];

                    if (result.endsWith(extension)) {
                        const vow = result;

                        keeper.addVow({
                            vow
                        });

                        /*
                            <><><><><><><><><><><><><><><>
                        */
                        require(vow);

                        // vows.push(vow);
                    }
                }

                task.done();
            },
            failure: (error) => {

            }
        });
    }
})
.task({
    id: 2,
    after: 1,
    fn: function() {
        // require("auriga/array/read")({
        //     array: vows,
        //     each: function(entry, index, next) {
        //         require(entry);
        //         next();
        //     },
        //     done: function() {
        //         keeper.endOfInput();
        //     }
        // });

        keeper.endOfInput();
    }
});









////
