
const progress= "◴◷◶◵";
const refresh_rate = 200; // refresh every 200 milliseconds
const output = "shell";

// const murex = require('murex');
// const archive = () => {};


const murex = () => {};
const archive = (act) => {
    console.dir(act, {
        depth: 1
    });
}

function Keeper({ base }) {
    this.base = base;
    this.ids = {};
    this._endOfInput = false;

    this.vows = {};

    this.index = 1;
    this.sections = {
        header: {
            start: 0,
            end: 0
        },
        body: {
            start: 0,
            end: 0,
            vows: {}
        },
        footer: {
            start: 0,
            end: 0
        }
    }
}
Keeper.prototype.options = function() {
    const keeper = this;

    function Options() {}
    Options.prototype = require('auriga/object/combine')(Options.prototype, {
        addVow: function({ vow }) {
            keeper.vows[ vow ] = {
                status: 'found'
            }
            keeper.act({
                act: 'vow found',
                vow: require('path').relative(
                    keeper.base,
                    vow
                )
            })
        },
        add: function({ key, caller_file, evaluated }) {
            const id = require('auriga/id/unique')(keeper.ids, "dojx");
            const relative_path = require('path').relative(
                keeper.base,
                caller_file
            );

            const index = keeper.index++ + 1;

            keeper.ids[ id ] = {
                key,
                relative_path,
                index,
                status: "started",
                write_loop: (() => {
                    let progress_index = 0;

                    return setInterval(() => {
                        if (progress_index === progress.length - 1) {
                            progress_index = 0;
                        }
                        else {
                            progress_index++;
                        }

                        const glyph = progress[progress_index];

                        // keeper.refresh();

                        // require('murex')({
                        //     line: {
                        //         [index]: `[${ glyph }] ${ key }`,
                        //     }
                        // });
                    }, 200)
                })(),
                proc: (() => {
                    const proc = require('venatici/fork')({
                        script: require('path').resolve(__dirname, "vow-test.js"),
                        env: {
                            NODE_PATH: require('path').resolve(__dirname, "plugins")
                        }
                    });

                    proc.send(evaluated)
                    proc.on('message', (status) => {
                        keeper.update({
                            event: status,
                            id
                        });
                    });

                    return proc;
                })()
            };

            keeper.act({
                id,
                act: 'guarantee started'
            });

            // require('murex')({
            //     line: {
            //         [index]: `[  ] ${ key }`,
            //     }
            // });

            return id;
        },
        endOfInput: function() {
            this._endOfInput = true;
        }
    });

    keeper.act({
        act: 'keeper started'
    });

    return new Options();
}

Keeper.prototype.act = function(act) {
    act.date = new Date();

    const { id = null } = act;
    if (id !== null) {
        const { relative_path } = this.ids[ id ];
        act.relative_path = relative_path;
    }

    if (act.act === 'keeper started') {
        if (output === 'shell') {
            this.sections.header.end += 9;
            this.sections.body.start += 10;
            this.sections.body.end += 10;
            this.sections.footer.start += 10;
            this.sections.footer.end += 10;

            const start = this.sections.header.start;
            const end = this.sections.header.end;

            murex({
                line: {
                    [start]: `◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱`,
                    [start + 1]: ``,
                    [start + 2]: `  Searching ◴`,
                    [start + 3]: `  0 vows found`,
                    [start + 4]: `  0 guarantees found`,
                    [start + 5]: ``,
                    [start + 6]: `  0 of 0 vows completed`,
                    [start + 7]: `  0 of 0 guarantees completed`,
                    [start + 8]: ``,
                    [this.sections.header.end]: `◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱◲◰◳◱`
                }
            });
        }
    }
    else if (act.act === 'vow found') {
        if (output === 'shell') {
            const start = this.sections.header.start;
            const end = this.sections.header.end;

            const {
                start: gStart,
                end: gEnd
            } = this.sections.body;

            const _vows = this.sections.body.vows;
            const last_index = Object.keys(_vows).length - 1;

            // this.sections.body.vows[ act.vow ]: {
            //     start:
            //     end:
            // }

            const found = Object.keys(this.vows).length;

            murex({
                line: {
                    [start + 3]: `  ${ found } vows found`,
                    [start + 6]: `  0 of ${ found } vows completed`,
                    [gStart]: ``,
                    [gStart + 1]: `  ${ act.vow }`
                }
            });
        }
    }
    else if (act.act === 'guarantee started') {
        if (output === 'shell') {
            const start = this.sections.header.start;
            const end = this.sections.header.end;

            const found = Object.keys(this.ids).length;

            // this.sections.vows.list.push({
            //     id,
            //     start: gStart,
            //     // end:
            // });

            // murex({
            //     line: {
            //         [start + 4]: `  ${ found } guarantees found`,
            //         [start + 7]: `  0 of ${ found } guarantees completed`,
            //     }
            // });
        }
    }
    else if (act.act === '') {

    }

    archive(act);
}
Keeper.prototype.update = function({ id, event }) {
    const { key, relative_path, index } = this.ids[ id ];

    if (event === "yes") {
        this.ids[ id ].status = "yes";
        clearInterval(this.ids[ id ].write_loop);

        this.act({
            id,
            act: 'yes'
        });

        // require('murex')({
        //     line: {
        //         [index]: `[✅ ] ${ key }`,
        //     }
        // });
    }
    else if (event === "no") {
        this.ids[ id ].status = "no";
        clearInterval(this.ids[ id ].write_loop);

        this.act({
            id,
            act: 'no'
        });

        // require('murex')({
        //     line: {
        //         [index]: `[❌ ] ${ key }`,
        //     }
        // });
    }

    this.tryDone();
}
Keeper.prototype.tryDone = function() {
    const doneStatuses = ["no", "yes"];

    if (this._endOfInput) {
        const vows = Object.keys(this.ids);
        for (let i = 0; i <= vows.length - 1; i++) {
            const { status } = this.ids[vows[i]];

            if (!doneStatuses.includes(status)) {
                return;
            }
        }

        // console.log('done')
        // all status
    }
}

module.exports = function() {
    const keeper = new (
        Function.prototype.bind.apply(
            Keeper,
            Array.prototype.concat.apply([null], arguments)
        )
    );

    return keeper.options();
}
